## texlive-base 2013.20140215

=== Makefile ===

PDFLATEX=pdflatex -shell-escape

all: pgfplots.pdf pgfplotstable.pdf TeX-programming-notes.pdf pgfplotstodo.pdf
	@echo "$^ have been compiled successfully. I did NOT check for references, so you may need to rerun make several times."

notes: TeX-programming-notes.pdf
todo: pgfplotstodo.pdf
pgfplots: pgfplots.pdf
pgfplotstable: pgfplotstable.pdf

# was: 
# export TEXMFCNF=.:
# but it seems as if that is ignored for some reason
TEXMFCNF_FOR_MEMLIMITS=export TEXMFCNF=~/texmf/mytexcnf:
TEXINPUTS:=$(TEXINPUTS):./plotdata

vpath %.dat ./plotdata

$(info texinputs = $(TEXINPUTS))

include pgfplots.makefile

%.pdf: revisionfile FORCE
	mkdir -p gnuplot
	@$(TEXMFCNF_FOR_MEMLIMITS) && $(PDFLATEX) $(@:.pdf=.tex)
	@bibtex $(@:.pdf=) || exit 0
	@makeindex $(@:.pdf=) || exit 0
	@echo ""
	@echo "$@ compiled successfully. You may need to re-run make several times to get all cross-references right."

html: FORCE
	mkdir -p html/figures/generated
	mkdir -p html/gnuplot
	# note: I could also change TEXINPUTS. But that would also include .aux files from the pdf version.
	# prefer a copy:
	cd html && ln -f -s ../*.tex ../*.sty ../*.dat ../plotdata .
	cd html/figures && ln -f -s `find ../../figures ! -name 'expensive*' -type f` .
	@cd html && \
		$(PDFLATEX) '\def\pgfplotsmanualhtlatexmode{1} \input pgfplots.tex'
	@cd html && \
		$(TEXMFCNF_FOR_MEMLIMITS) && \
		make -k -f pgfplots.makefile
	@cd html && \
		htlatex pgfplots.tex "../pgfplots.tex4ht.cfg"
		

pgfplots.pdf: $(ALL_FIGURES)

pgfplots.makefile:
	@$(TEXMFCNF_FOR_MEMLIMITS) && $(PDFLATEX) pgfplots
	
clean:
	rm -f *.aux *.ind *.idx *.toc *.out *.log *.ilg *.dvi pgfplots.makefile pgfplots.pdf pgfplotstable.pdf *.djs *.bbl *.blg figures/expensiveexample*


revisionfile:
	cd ../../.. && ./scripts/pgfplots/pgfplotsrevisionfile.sh

FORCE:

=== regressiontests/Makefile ===
# This is a regression-test framework for tex.
#
# The idea is as follows:
#
# 1. there is a reference revision on which a unittest runs as expected.
# 2. there is a way to generate the reference image (to pdf and to png)
# 3. you can compile the actual image
# 4. you can "diff" the actual image and the reference (and view the difference)
# 5. you can create a log of the single results and diffs
#
# This makefile can do all of these steps.
#
# The references can be generated with
# >> make references
# References are stored in a sub-folder called "references". You can *REMOVE* this directory
# to clean references.
#
# References are compiled using different revisions of the code; they are checked out into /tmp. 
#
#
# HOW TO WRITE TESTS
# Simply write a minimal, self-contained .tex file (say, unittest_42.tex) in this directory. It can have multiple
# pages.
# 
# If a test contains \FIXIT, it is marked as "this test is known to be broken - test issue"
#
#
# If your example needs a specific reference revision, create a file <base>.checkoutreferencerev.sh which contains something
# like "git checkout 1.3.1" . It will be invoked to checkout the reference revision.
#
# If your example needs a specific command to translate it, create a file <base>.compile.sh which runs it. Its first argument will be the base file name (without .tex).
#
# Then, type "make unittest_42.diff" to create reference, actual, and difference.
#
# Typing 'make' will make all unittests (all *.tex files in this directory).
#  
# COMPILING TESTS
# 1. compile reference, actual, and diff:
# >> make unittest_polar_7.diff
# 2. compile reference only
# >> make references/unittest_polar_7.pdf
# 3. compile actual only
# >> make unittest_polar_7.pdf
#
# The makefile will avoid re-creation of test cases in order to allow concentrate on failures.
# If you want to remake tests, you can either type 
# >> make clean
# or you can use the (standard) make feature 
# >> make unittest_polar_7.diff -B
# which forces remake, even if modtimes are unchanged 
#
#
# SPECIALTIES:
# create a file unittest_*.diff.accepted containing accepted diff results 
# (in case you approved that they are "not an error"). 
# The file should contain what the failure-output of the 'make test.diff' target.

UNIT_SOURCES=$(wildcard unittest_*.tex)

UNIT_PDFS=$(UNIT_SOURCES:.tex=.pdf)
DIFF_MEASURES=$(UNIT_SOURCES:.tex=.diff)

# REQUIRES apcalc package ('calc' executable)
ACCEPTED_NORMALIZED_ERROR=5e-4
DIRECTORY_FOR_ACCEPTED_ERRORS=./pgfplotsUTaccepted

INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY=plotdata/risingdrop3d.png plotdata/plotgraphics3dsurf.png

# -------------------------------------------------
# stuff for references:
# allow dynamic creation of reference files. I have never used something else.
ENABLE_DYNAMIC_REFERENCES=1

STATISTICS=$$(ls unittest_*.pdf | wc -l)/$$(ls unittest_*.tex | wc -l) [F=$$(find -maxdepth 1 -name 'unittest_*.diff.png' | wc -l)]

UNIT_PDF_REFERENCES=$(UNIT_SOURCES:%.tex=references/%.pdf)
WORKING_DIR=$(shell pwd)
PGFPLOTS_GIT_BASEDIR=$(WORKING_DIR:source/latex/pgfplots/pgfplotstest/regressiontests=)
TMP_REPOSITORY=/tmp/pgfplots_copy
DEFAULT_REFERENCE_BRANCH:=$(shell git describe --tags HEAD)

PGF_CVS_PATH=~/code/tex/pgf
PGF_REFERENCE_PATH=$(PGF_CVS_PATH)
#PGF_REFERENCE_PATH=~/code/tex/pgf_2.10/tex

.PRECIOUS:  $(UNIT_SOURCES:%.tex=%.checkoutreferencerev.sh) $(UNIT_SOURCES:%.tex=%.compile.sh) $(UNIT_PDF_REFERENCES) $(UNIT_SOURCES:%.tex=%.pdf)

AUTO_INDENT_PIPE=2>&1 | sed -e 's/^/  /'
$(shell mkdir -p gnuplot references/gnuplot references/plotdata)
# -------------------------------------------------

.NOTPARALLEL:

# .PRECIOUS: $(UNIT_PNGS)

.PHONY: references pdf png  cleanX clean setupdirs

diff: $(DIFF_MEASURES) 

pdf: $(UNIT_PDFS) 

clean: cleanX
	rm -fr references 

# clean all except for references:
cleanX:
	rm -fr $(DIFF_MEASURES) $(UNIT_PDFS) unittest*.png $(DIRECTORY_FOR_ACCEPTED_ERRORS)

%.diff.png: %.diff
	@

%.diff: %.pdf references/%.pdf
	@echo "$<: diffing --> $@ ..."
	@./pdfdiff.sh $< references/$< $@
	@if [ "`cat $@`" = "0 (0)" ]; then \
		echo "  PASSED: no differences detected (removing superfluos diff-pngs)"; \
		rm -f $@.png $<.png $(DIRECTORY_FOR_ACCEPTED_ERRORS)/$@ $(DIRECTORY_FOR_ACCEPTED_ERRORS)/$@.png; # no need to keep the images (the latter for multi-page mode). \
	else \
		#echo "$<: found nonzero pixel differences `cat $@`."; \
		sed -e 's/.*(\(.*\)).*/\1/' < $@  > $@.normalized || exit 1; \
		NORMALIZED=`cat $@.normalized`; \
		rm -f $@.normalized; \
		calc -p "$$NORMALIZED < $(ACCEPTED_NORMALIZED_ERROR)" > $@.isaccepted || ( echo "calc invocation failed. Please ensure that apcalc package is installed."; exit 1 ); \
		if [ ! -f $@.accepted -a "`cat $@.isaccepted`" = "1" ]; then \
			echo "  PASSED: only approved differences `cat $@` detected and no *.accepted (less than $(ACCEPTED_NORMALIZED_ERROR); moving superfluos diff-pngs to $(DIRECTORY_FOR_ACCEPTED_ERRORS))"; \
			mkdir -p $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			mv $@.png $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			cp $@ $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			rm -f $@.png $<.png; # no need to keep the images (the latter for multi-page mode). \
		elif [ -f $@.accepted -a "`cat $@`" = "`cat $@.accepted`" ]; then \
			echo "  PASSED: only manually approved differences `cat $@` detected (moving superfluos diff-pngs to $(DIRECTORY_FOR_ACCEPTED_ERRORS))"; \
			mkdir -p $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			mv $@.png $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			cp $@ $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			rm -f $@.png $<.png; # no need to keep the images (the latter for multi-page mode). \
		else \
			echo "  FAILURE: found pixel differences for $<: " `cat $@`; \
			echo "  (if not a bug: 'echo \"`cat $@`\" > $@.accepted')"; \
			echo "  Call './displayDiff.sh $@.png' (see summarize of regressions.sh)"; \
			rm $@; # make sure it will be recomputed! \
			false; \
		fi; \
		CODE=$$?; \
		rm -f $@.isaccepted; \
		exit $$CODE; \
	fi
		


#	convert $< -append $@
#	@diff $@ references/$@; \
#	if [ ! $$? -eq 0 ]; then \
#		echo 'convert "$@" "references/$@" -compose difference -composite -colorspace gray miff:- | display' > $(@:.png=.regression.sh); \
#		echo "echo $@" >> regressions.sh; \
#		echo "sh $(@:.png=.regression.sh)" >> regressions.sh; \
#		echo "$@ WAS UNEXPECTED. See regressions.sh"; \
#		touch -t 01010000 $@; # make sure its older MMDDHHSS\
#		false;\
#	fi
	
		

references: $(UNIT_PDF_REFERENCES)

%.checkoutreferencerev.sh:
	@if [ ! -f $@ ]; then pwd; echo "generating $@ (with $(DEFAULT_REFERENCE_BRANCH))..."; echo "git checkout $(DEFAULT_REFERENCE_BRANCH)" > $@ || exit 1; fi

ifeq ($(ENABLE_DYNAMIC_REFERENCES),1)

references/%.pdf: %.tex %.checkoutreferencerev.sh %.compile.sh
	@echo "$<: generating $@"; \
	REFERENCE_SCRIPT=$(<:.tex=.checkoutreferencerev.sh);\
	#echo "  checking out reverence revision to $(TMP_REPOSITORY)..."; \
	if [ ! -d $(TMP_REPOSITORY) ]; then \
		cd $(dir $(TMP_REPOSITORY)) || exit 1; \
		git clone $(PGFPLOTS_GIT_BASEDIR) $(notdir $(TMP_REPOSITORY)) || exit 1; \
	fi; \
	cd $(TMP_REPOSITORY) || exit 1; \
	git reset --hard >/dev/null 2>&1; \
	cat $(WORKING_DIR)/$$REFERENCE_SCRIPT $(AUTO_INDENT_PIPE); \
	sh $(WORKING_DIR)/$$REFERENCE_SCRIPT  1>/dev/null 2>&1; \
	if [ $$? -ne 0 ]; then \
		echo "CHECKOUT FAILED." $(AUTO_INDENT_PIPE); \
		echo "(cleaning $(TMP_REPOSITORY))..." $(AUTO_INDENT_PIPE); \
		rm -fr $(TMP_REPOSITORY); \
		exit 1; \
	fi
	@#./patch_repository.sh $(TMP_REPOSITORY)
	@cd references || exit 1;\
	export TEXINPUTS=.:..:$(TMP_REPOSITORY)/tex//:$(PGF_REFERENCE_PATH)/generic//:$(PGF_REFERENCE_PATH)/latex//:$(TEXINPUTS); \
	echo "export TEXINPUTS=$${TEXINPUTS}:\$$TEXINPUTS" $(AUTO_INDENT_PIPE); \
	echo "cd references && \"compile $<\" ..." $(AUTO_INDENT_PIPE); \
	# create *.diff.png -> this makes it much more visible that it failed: \
	sh ../$(<:.tex=.compile.sh) $(<:.tex=) 1>$(<:.tex=.log.all) 2>&1 || \
		( sh ../../scripts/compile_failed.sh "../$<" "$@" "\nPlease check $(<:.tex=.checkoutreferencerev.sh)" $(AUTO_INDENT_PIPE); exit 1 )

else
#disable dynamic reference (re-)creation:
references/%.pdf: %.tex 
	@if [ ! -f $@ ]; then echo "  REFERENCE IS MISSING AND CAN'T BE CREATED AUTOMATICALLY (ENABLE_DYNAMIC_REFERENCES=0)"; exit 1; fi

endif

# make sure this rule is AFTER references/%.pdf !
%.pdf: %.tex %.compile.sh $(INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY)
	@echo "$(STATISTICS) $@: recompiling $< ..."
	@rm -f $@; sh ./$(@:.pdf=.compile.sh) $(<:.tex=) >/dev/null 2>&1  || \
		( sh ../scripts/compile_failed.sh "$<" "$@" "" $(AUTO_INDENT_PIPE); exit 1 )

%.compile.sh:
	@if [ ! -f $@ ]; then echo "generating default $@ ..."; echo 'pdflatex -shell-escape -interaction batchmode -halt-on-error "$$@"' > $@; fi

# temporary links to graphics which are in the doc directory:
# see $(INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY)
plotdata/%: 
	cd plotdata && ln -fs ../../../../../../doc/latex/pgfplots/plotdata/$(notdir $@)

=== texmf-dist/doc/latex/listings/Makefile ===
### Makefile ---
#
# This file generates files required to use the listings package.
#
# $Id: Makefile 80 2013-08-05 17:46:11Z j_hoffmann $
#
# (c) 2007 Brooks Moses
# (c) 2013 Jobst Hoffmann
#
# This file is distributed under the terms of the LaTeX Project Public
# License from CTAN archives in directory  macros/latex/base/lppl.txt.
# Either version 1.3 or, at your option, any later version.

# remember:
# $<: first element of list of dependees
# $^: list of (all) dependees
# $@: target

# formatting tools
LATEX = pdflatex
MAKEINDEX = makeindex
TEX = tex
# tarring options
ifneq "$(wildcard listings.version)" ""
include listings.version        # version and date of the package
endif
TAR_SRC = $(PACKAGE)-$(VERSION)_source.tar.gz
EXsvn = --exclude .svn --exclude auto --exclude contrib --exclude requests \
	--exclude support --exclude testing \
	--exclude *.gz --exclude *.txt

DISTRIBUTION_FILES = $(PACKAGE).pdf $(PACKAGE).dtx \
	$(PACKAGE).ins README Makefile \
	lstdrvrs.dtx lstdrvrs.ins lstdrvrs.pdf 


.SUFFIXES:                              # Delete the default suffixes
.SUFFIXES: .dtx .ins .pdf .sty          # Define our own suffix list

.PHONY: listings pdf pdf-devel tests all

listings: listings.sty

pdf: listings.pdf lstdrvrs.pdf

pdf-devel: listings-devel.pdf

all: listings pdf pdf-devel


listings.sty: listings.ins listings.dtx lstdrvrs.dtx
	$(TEX) $<

listings.pdf: listings.sty
	rm -f ltxdoc.cfg
	$(LATEX) ${<:.sty=.dtx}
	$(MAKEINDEX) -s gind.ist ${@:.pdf=}
	$(LATEX) ${<:.sty=.dtx}
	$(LATEX) ${<:.sty=.dtx}

listings-devel.pdf: listings.sty
	rm -rf ltxdoc.cfg
	echo "\AtBeginDocument{\AlsoImplementation}" > ltxdoc.cfg
	$(LATEX) -jobname=${@:.pdf=} ${<:.sty=.dtx}
	$(MAKEINDEX) -s gind.ist ${@:.pdf=}
	$(LATEX) -jobname=${@:.pdf=} ${<:.sty=.dtx}
	$(LATEX) -jobname=${@:.pdf=} ${<:.sty=.dtx}
	rm -rf ltxdoc.cfg

lstdrvrs.pdf: lstdrvrs.dtx
	rm -f ltxdoc.cfg
	$(LATEX) ${<:.sty=.dtx}
	$(MAKEINDEX) -s gind.ist lstdrvrs
	$(LATEX) ${<:.sty=.dtx}
	$(LATEX) ${<:.sty=.dtx}

## Testing targets
fortran-tests:
	cd testing; make fortran

gap-tests:
	cd testing; make gap

llvm-tests:
	cd testing; make llvm

lua-tests:
	cd testing; make lua

tests:
	cd testing; make all

## Clean targets
clean:
	-rm -f  *~ *.aux *.lof *.log *.lot *.tmp *.toc
	-rm -f *.idx *.ind *.glg *.glo *.gls *.ilg *.out
	-rm -f *.bbl *.blg *.brf

clean-results:
	-rm -f *.cfg *.pdf *.prf *.sty

realclean:  clean clean-results

### create packed files
tar-src:
	@$(MAKE) realclean; \
	sed -i -e "s+fileversion{[a-z0-9\.\-]*}+fileversion{$(VERSION)}+g" \
	    -e "s+filedate{[0-9/]*}+filedate{$(DATE)}+g" \
	    -e "s+date{[0-9/]*\\\\enspace+date{$(DATE)\\\\enspace+g" \
	    -e "s+Version [a-z0-9\.\-]*\\\\+Version $(VERSION)\\\\+g" \
		listings.dtx; \
	sed -i -e "s+date{[0-9/]*\\\\enspace+date{$(DATE)\\\\enspace+g" \
	    -e "s+Version [a-z0-9\.\-]*\\\\+Version $(VERSION)\\\\+g" \
	    -e "s+\[[0-9/]* [a-z0-9\.\-]* listings+[$(DATE) $(VERSION) listings+g" \
		lstdrvrs.dtx; \
	cd ..; tar $(EXsvn) -czvf $(PACKAGE)/$(TAR_SRC) $(PACKAGE)

tar-dist: $(DISTRIBUTION_FILES)
	@$(MAKE) realclean; \
	sed -i -e "s+fileversion{[a-z0-9\.\-]*}+fileversion{$(VERSION)}+g" \
	    -e "s+filedate{[0-9/]*}+filedate{$(DATE)}+g" \
	    -e "s+date{[0-9/]*\\\\enspace+date{$(DATE)\\\\enspace+g" \
	    -e "s+Version [a-z0-9\.\-]*\\\\+Version $(VERSION)\\\\+g" \
		listings.dtx; \
	sed -i -e "s+date{[0-9/]*\\\\enspace+date{$(DATE)\\\\enspace+g" \
	    -e "s+Version [a-z0-9\.\-]*\\\\+Version $(VERSION)\\\\+g" \
	    -e "s+\[[0-9/]* [a-z0-9\.\-]* listings+[$(DATE) $(VERSION) listings+g" \
		lstdrvrs.dtx; \
	$(MAKE) listings.pdf; \
	$(MAKE) lstdrvrs.pdf; \
	tar cfvz $(PACKAGE)-$(VERSION).tgz $^;

## Documentation target
help::
	$(info Usage:)
	$(info )
	$(info make [all]	generates listings.sty and [all] the .pdf versions)
	$(info $(empty)		(user/developer) of the documentation)
	$(info )
	$(info make <file name>)
	$(info $(empty)		creates the corresponding file denoted by <file name>)
	$(info )
	$(info make help	shows this help)
	$(info )
	$(info make tests	performs a little test suite)
	$(info )
	$(info make clean	removes all intermediate files created by a LaTeX run)
	$(info )
	$(info make clean-results)
	$(info $(empty)		removes .cfg, .sty, and .pdf files)
	$(info )
	$(info make realclean)
	$(info $(empty)		performs clean and clean-results)
	$(info )
	$(info make tar-src)
	$(info $(empty)		generates a tarred version of the current directory)
	$(info )
	$(info make tar-dist)
	$(info $(empty)		generates a distributable version of the listings)
	$(info $(empty)		package)
	@echo ""					# prevents message "nothing to do ..."

### Makefile ends here ---

=== texmf-dist/doc/latex/tkz-orm/Makefile ===
################################################################
# Makefile for tkz-orm                                         #
################################################################

help:
	@echo ""
	@echo " make clean   - clean out directory"
	@echo " make tidy    - clean out directory some more"
	@echo " make ctan    - create a CTAN-ready archive"
	@echo " make doc     - typeset documentation"
	@echo " make install - install files in local texmf tree"
	@echo ""

################################################################
# Master package name                                          #
################################################################

PACKAGE = tkz-orm
FEATURES = index bib

LATEXFLAGS = -interaction=nonstopmode

################################################################
# Directory structure for making zip files                     #
################################################################

CTANROOT := ctan
CTANDIR  := $(CTANROOT)/$(PACKAGE)
CTANINCLUDE = $(PACKAGE).tex $(PACKAGE).sty $(PACKAGE).bib \
	README LICENSE pgfmanualstyle.sty Makefile

###############################################################
# Data for local installation
###############################################################

# TODO: add cheatsheet
INCLUDEPDF  := $(PACKAGE)
PACKAGEROOT := latex/$(PACKAGE)

################################################################
# Clean-up information                                         #
################################################################

AUXFILES = aux bbl bit blg glo gls dvi glo hd idx ilg ind lof \
	log nlo nls out toc

CLEAN = gz pdf ps zip

################################################################
# File buiding: default actions                                #
################################################################

all: $(PACKAGE).pdf
index: $(PACKAGE).ind $(PACKAGE).ilg
abbr: $(PACKAGE).nls
bib: $(PACKAGE).blg $(PACKAGE).bbl

# Documentation
$(PACKAGE).pdf: $(PACKAGE).tex $(FEATURES)
	pdflatex $(LATEXFLAGS) $(PACKAGE).tex
	pdflatex $(LATEXFLAGS) $(PACKAGE).tex
 
# Preperation
$(PACKAGE).idx $(PACKAGE).nlo $(PACKAGE).aux: $(PACKAGE).tex
	pdflatex $(LATEXFLAGS) $(PACKAGE).tex
 
# Indexes
$(PACKAGE).ind $(PACKAGE).ilg: $(PACKAGE).tex $(PACKAGE).idx
	makeindex $(PACKAGE).idx

$(PACKAGE).nls: $(PACKAGE).tex $(PACKAGE).nlo
	makeindex $(PACKAGE).nlo -s nomencl.ist -o $(PACKAGE).nls

# Bibliography
$(PACKAGE).blg $(PACKAGE).bbl: $(PACKAGE).tex $(PACKAGE).bib $(PACKAGE).aux
	bibtex $(PACKAGE)

%.pdf2: %.tex
	NAME=`basename $< .tex` ; \
	echo "Typesetting $$NAME" ; \
	pdflatex &> /dev/null ; \
	if [ $$? = 0 ] ; then  \
	  makeindex -s gglo.ist -o $$NAME.gls $$NAME.glo &> /dev/null ; \
	  makeindex -s gind.ist -o $$NAME.ind $$NAME.idx &> /dev/null ; \
	  pdflatex &> /dev/null ; \
	  pdflatex &> /dev/null ; \
	else \
	  echo "  Complilation failed" ; \
	fi ; \
	for I in $(AUXFILES) ; do \
	  rm -f $$NAME.$$I ; \
	done

################################################################
# User make options                                            #
################################################################

.PHONY = clean tidy install

clean:
	for I in $(AUXFILES) $(CLEAN) ; do \
	  rm -f *.$$I ; \
	done
	@rm -rf $(CTANROOT)/

tidy: clean
	@rm -rf *~

ctan: doc
	echo "Creating CTAN archive"
	mkdir -p $(CTANDIR)/
	rm -rf $(CTANDIR)/*
	for I in $(INCLUDEPDF) ; do \
	  cp -f $$I.pdf $(CTANDIR)/ ; \
	done ; \
	for F in $(CTANINCLUDE) ; do \
	  cp -f $$F $(CTANDIR)/ ; \
	done ; \
	cd $(CTANDIR) ; \
	zip -ll -q -r -X $(PACKAGE).zip .
	cp $(CTANDIR)/$(PACKAGE).zip ./
	rm -rf $(CTANROOT)/

doc: $(foreach FILE,$(INCLUDEPDF),$(FILE).pdf)

install: 
	echo Installing $(PACKAGE).sty
	TEXMFHOME=`kpsewhich --var-value=TEXMFHOME` ; \
	rm -rf $$TEXMFHOME/tex/$(PACKAGEROOT)/*.* ; \
	mkdir -p $$TEXMFHOME/tex/$(PACKAGEROOT)/ ; \
	cp $(PACKAGE).sty $$TEXMFHOME/tex/$(PACKAGEROOT)/ ; \
	texhash &> /dev/null

=== texmf-dist/doc/pdftex/manual/Makefile ===
# $Id: Makefile 656 2010-11-23 01:20:14Z karl $
#
# Makefile for pdfTeX documentation

pdftexversion=1.40.11
mandir=manual
distdate=`date +%y%m%d`
distrev=`awk '/Id:/{print $$4; exit}' $(mandir)/pdftex-t.tex`

distall=$(distnopdf) pdftex-a.pdf pdftex-l.pdf pdftex-s.pdf

distnopdf=pdftex-w.tex pdftex-t.txt pdftex-t.tex \
	pdftex-i.tex syntaxform.awk Makefile makefiles.cmd \
	pdftex-syntax.txt README ChangeLog

all:	pdftex-a.pdf \
	pdftex-l.pdf \
	pdftex-s.pdf \
	pdftex-syntax.txt

booklet:	pdftex-b.pdf pdftex-b-e.pdf pdftex-b-o.pdf

pdftex-a.pdf a:	pdftex-t.tex pdftex-t.txt
	texexec --result=$@ $<

pdftex-l.pdf l:	pdftex-t.tex pdftex-t.txt
	texexec --mode=letter --result=$@ $<

pdftex-s.pdf s:	pdftex-t.tex pdftex-i.tex
	texexec --mode=screen --result=$@ $<

pdftex-b.pdf b:	pdftex-a.pdf
	texexec --pdfarrange --paper=a5a4 --print=up --addempty=1,2 \
	--result=$@ $<

pdftex-b-e.pdf:	pdftex-a.pdf
	texexec --pdfarrange --paper=a5a4 --print=up --addempty=1,2 \
	--pages=even --result=$@ $<

pdftex-b-o.pdf:	pdftex-a.pdf
	texexec --pdfarrange --paper=a5a4 --print=up --addempty=1,2 \
	--pages=odd --result=$@ $<

pdftex-t.txt:	pdftex-w.pdf Makefile
	cat $< \
	| expand \
	| fmt -s -w36 \
	| env GREP_OPTIONS=--text grep . \
	| expand \
	| cat > $@

pdftex-w.pdf:	pdftex-w.tex
	pdftex $<

pdftex-syntax.txt:	pdftex-t.tex syntaxform.awk
	gawk -f syntaxform.awk $< > $@

# tar/zip including pdftex-a.pdf, pdftex-l.pdf, pdftex-s.pdf:

alltar:	$(distall)
	cd .. && tar cvjf $(mandir)/pdftex-$(pdftexversion)-userman-$(distrev).tar.bz2 \
	$(patsubst %, $(mandir)/%, $(distall))

allzip:	$(distall)
	cd .. && zip $(mandir)/pdftex-$(pdftexversion)-userman-$(distrev).zip \
	$(patsubst %, $(mandir)/%, $(distall))

# tar/zip without PDF files:

tar:	$(distnopdf)
	cd .. && tar cvjf $(mandir)/pdftex-$(pdftexversion)-userman-$(distrev)-src.tar.bz2 \
	$(patsubst %, $(mandir)/%, $(distnopdf))

zip:	$(distnopdf)
	cd .. && zip $(mandir)/pdftex-$(pdftexversion)-userman-$(distrev)-src.zip \
	$(patsubst %, $(mandir)/%, $(distnopdf))

clean:
	texutil --purge

allclean:
	- rm -f pdftex-a.pdf pdftex-l.pdf pdftex-s.pdf
	- rm -f pdftex-b.pdf pdftex-b-e.pdf pdftex-b-o.pdf
	- rm -f pdftex-syntax.txt
	- rm -f pdftex-w.pdf pdftex-t.txt
	make clean

clobber: allclean

=== texmf-dist/doc/support/lua-alt-getopt/Makefile ===
PREFIX?=/usr/local
LUAVER?=5.1
LUAMODDIR?=${PREFIX}/lib/lua/${LUAVER}

##################################################

VERSION=		0.7.0
PROJECTNAME=		lua-alt-getopt
BIRTHDATE=		2009-01-10

FILES=			alt_getopt.lua
FILESDIR=		${LUAMODDIR}

INST_DIR?=		${INSTALL} -d

##################################################
.PHONY: install-dirs
install-dirs:
	$(INST_DIR) ${DESTDIR}${LUAMODDIR}

.PHONY: test
test:
	@echo 'running tests...'; \
	ln -f -s ${.CURDIR}/alt_getopt.lua ${.CURDIR}/tests; \
	export OBJDIR=${.OBJDIR}; \
	if cd ${.CURDIR}/tests && ./test.sh; \
	then echo '   succeeded'; \
	else echo '   failed'; false; \
	fi

.include <bsd.prog.mk>

=== texmf-dist/source/latex/fontspec/Makefile ===
# Makefile for fontspec.

#### MAKEFILE CONFIG ####

SHELL = /bin/sh
.SUFFIXES:
.SILENT:

#### BEGIN ####

help:
	@echo 'FONTSPEC makefile targets:'
	@echo ' '
	@echo '                  help  -  (this message)'
	@echo '                unpack  -  extracts all files'
	@echo '                   doc  -  compile documentation'
	@echo '                gendoc  -  compile documentation including external examples'
	@echo '                  ctan  -  generate archive for CTAN'
	@echo '                   all  -  unpack & doc'
	@echo '                 world  -  all & ctan'
	@echo '                 clean  -  remove all generated and built files'
	@echo ' '
	@echo '                   install  -  install the complete package into your home texmf tree'
	@echo '               sty-install  -  install the package code only'
	@echo ' install TEXMFROOT=<texmf>  -  install the package into the path <texmf>'
	@echo ' '
	@echo '                 check  -  run the test suite'
	@echo '               initest  -  initialise any new tests'
	@echo '            <testname>  -  run only this test'
	@echo ' '
	@echo 'I recommend `make -j4 check` or thereabouts to parallelise'
	@echo 'the testing.'


NAME = fontspec
DOC = $(NAME).pdf
DTX = $(NAME).dtx

# Redefine this to print output if you need:
REDIRECT = > /dev/null

# Files grouped by generation mode
COMPILED = $(DOC) fontspec-testsuite.pdf
EXAMPLES = fontspec-example.tex
UNPACKED = fontspec.sty fontspec-xetex.sty fontspec-luatex.sty fontspec-patches.sty fontspec.lua fontspec.cfg $(EXAMPLES)
SOURCE = $(DTX) Makefile README
GENERATED = $(COMPILED) $(UNPACKED)

TESTS = $(wildcard testsuite/*.cls testsuite/*.tex testsuite/*.ltx)

DOC_DIR = doc-files
DOC_EXAMPLES = $(shell ls $(DOC_DIR)/*.pdf)

CTAN_FILES = $(SOURCE) $(COMPILED) $(EXAMPLES) $(DOC_EXAMPLES)

# Files grouped by installation location
UNPACKED_DOC = fontspec-example.tex

RUNFILES = $(filter-out $(UNPACKED_DOC), $(UNPACKED))
DOCFILES = $(COMPILED) README $(UNPACKED_DOC)
SRCFILES = $(DTX) Makefile

ALL_FILES = $(RUNFILES) $(DOCFILES) $(SRCFILES)

# Installation locations
FORMAT = latex
RUNDIR = $(TEXMFROOT)/tex/$(FORMAT)/$(NAME)
DOCDIR = $(TEXMFROOT)/doc/$(FORMAT)/$(NAME)
SRCDIR = $(TEXMFROOT)/source/$(FORMAT)/$(NAME)
TEXMFROOT = $(shell kpsewhich --var-value TEXMFHOME)

CTAN_ZIP = $(NAME).zip
TDS_ZIP = $(NAME).tds.zip
ZIPS = $(CTAN_ZIP) $(TDS_ZIP)

DO_PDFLATEX = pdflatex --interaction=nonstopmode $<  $(REDIRECT)
DO_PDFLATEX_WRITE18 = pdflatex --shell-escape --interaction=nonstopmode $<  $(REDIRECT)
DO_TEX = tex --interaction=nonstopmode $<  $(REDIRECT)
DO_MAKEINDEX = makeindex -s gind.ist $(subst .dtx,,$<)  $(REDIRECT)  2>&1

all: $(GENERATED)
doc: $(COMPILED)
unpack: $(UNPACKED)
ctan: $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

gendoc: $(DTX)
	@mkdir -p $(DOC_DIR)
	$(DO_PDFLATEX_WRITE18)

$(DOC): $(DTX)
	@echo "Compiling documentation"
	$(DO_PDFLATEX)
	$(DO_MAKEINDEX)
	@echo "Re-compiling documentation"
	$(DO_PDFLATEX)
	@echo "Re-re-compiling documentation"
	$(DO_PDFLATEX)

$(UNPACKED): $(DTX)
	@$(DO_TEX)

$(CTAN_ZIP): $(CTAN_FILES) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	@zip -9 $@ $^ >/dev/null

define run-install
@mkdir -p $(RUNDIR) && cp $(RUNFILES) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCFILES) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCFILES) $(SRCDIR)
@mkdir -p $(SRCDIR)/testsuite/ && cp $(TESTS) $(SRCDIR)/testsuite/
endef

define run-sty-install
@mkdir -p $(RUNDIR) && cp $(RUNFILES) $(RUNDIR)
endef

$(TDS_ZIP): TEXMFROOT=./tmp-texmf
$(TDS_ZIP): $(ALL_FILES)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	$(run-install)
	@cd $(TEXMFROOT) && zip -9 ../$@ -r . >/dev/null
	@$(RM) -r -- $(TEXMFROOT)

# Rename the README for CTAN
README: README.markdown
	cp $< $@

# lazy:
fontspec-testsuite.pdf: $(DTX)
	@echo 'Compiling test suite.'
	$(DO_PDFLATEX)
	xelatex --interaction=nonstopmode fontspec-testsuite.tex  $(REDIRECT)

.PHONY: install manifest clean mrproper

install: $(ALL_FILES)
	@if test ! -n "$(TEXMFROOT)" ; then \
		echo "Cannot locate your home texmf tree. Specify manually with\n\n    make install TEXMFROOT=/path/to/texmf\n" ; \
		false ; \
	fi ;
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

sty-install: $(RUNFILES)
	@if test ! -n "$(TEXMFROOT)" ; then \
		echo "Cannot locate your home texmf tree. Specify manually with\n\n    make install TEXMFROOT=/path/to/texmf\n" ; \
		false ; \
	fi ;
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

manifest: 
	@echo "Source files:"
	@for f in $(SOURCE); do echo $$f; done
	@echo ""
	@echo "Derived files:"
	@for f in $(GENERATED); do echo $$f; done

clean:
	@$(RM) -- *.log *.aux *.toc *.idx *.ind *.ilg *.glo *.gls *.example *.out *.synctex* *.tmp fontspec-style.sty *.ins fontspec*.pdf
	@$(RM) -- $(GENERATED) $(ZIPS)
	@$(RM) -- $(builddir)/*


#############
# TESTSUITE #
#############

#### Needed to compile and make stuff ####

builddir=build
testdir=testsuite
lprefix=L
xprefix=X
both=F

COPY = cp -a
MOVE = mv -f
COMPARE_OPTS = -density 300x300 -metric ae -fuzz 35%

LTXSOURCE = $(NAME).sty $(NAME)-xetex.sty $(NAME)-luatex.sty $(NAME).cfg $(NAME)-patches.sty

TESTLIST = testsuite-listing.tex

SUITESOURCE = \
  $(testdir)/testsuite.cls \
  $(testdir)/$(TESTLIST)

TESTOUT = $(wildcard $(testdir)/*.*safe.pdf)
BUILDTESTSRC = $(subst $(testdir)/,$(builddir)/,$(subst .safe.pdf,.ltx,$(TESTOUT)))
BUILDTESTTARGET1 = $(TESTOUT)
BUILDTESTTARGET2 = $(subst $(testdir)/,$(builddir)/,$(BUILDTESTTARGET1))
BUILDTESTTARGET3 = $(subst .Xsafe.pdf,-X.diff.pdf,$(BUILDTESTTARGET2))
BUILDTESTTARGET4 = $(subst .Lsafe.pdf,-L.diff.pdf,$(BUILDTESTTARGET3))
BUILDTESTTARGET = $(BUILDTESTTARGET4)

BUILDSOURCE = $(addprefix $(builddir)/,$(LTXSOURCE))
BUILDSUITE  = $(subst $(testdir)/,$(builddir)/,$(SUITESOURCE))
BUILDFILES  = $(BUILDSOURCE) $(BUILDSUITE) $(BUILDTESTSRC)

#### All tests ####

check: $(TESTLIST)

$(TESTLIST): $(BUILDFILES) $(BUILDTESTTARGET)
	@cd $(testdir); \
	ls *.ltx | sed -e 's/\(.*\).ltx/\\TEST{\1}/g' > $(TESTLIST)

$(builddir)/%: $(testdir)/%
	@mkdir -p $(builddir); \
	$(COPY) $< $@

$(builddir)/%: %
	@mkdir -p $(builddir); \
	$(COPY) -f $< $@


#### Generating new tests ####

lonelystub = $(shell cd $(testdir); ls | egrep '(X|L)(.*\.ltx)|(X|L)(.*\.safe.pdf)' | cut -d . -f 1 | uniq -u)
lonelyfile = $(addsuffix .safe.pdf,$(lonelystub))
lonelypath = $(addprefix $(testdir)/,$(lonelyfile))
lonelytest = $(addprefix $(builddir)/,$(addsuffix .pdf,$(lonelystub)))

Xlonelystub = $(shell cd $(testdir); ls | egrep '(F.*\.ltx)|(F.*.Xsafe.pdf)' | cut -d . -f 1 | uniq -u)
Xlonelyfile = $(addsuffix .Xsafe.pdf,$(Xlonelystub))
Xlonelypath = $(addprefix $(testdir)/,$(Xlonelyfile))
Xlonelytest = $(addprefix $(builddir)/,$(addsuffix -X.pdf,$(Xlonelystub)))

Llonelystub = $(shell cd $(testdir); ls | egrep '(F.*\.ltx)|(F.*.Lsafe.pdf)' | cut -d . -f 1 | uniq -u)
Llonelyfile = $(addsuffix .Lsafe.pdf,$(Llonelystub))
Llonelypath = $(addprefix $(testdir)/,$(Llonelyfile))
Llonelytest = $(addprefix $(builddir)/,$(addsuffix -L.pdf,$(Llonelystub)))

initest: $(lonelypath) $(Xlonelypath) $(Llonelypath)

$(lonelypath): $(lonelytest)
	$(COPY)  `echo $@ | sed -e s/$(testdir)/$(builddir)/ -e s/.safe.pdf/.pdf/`  $@

$(Xlonelypath): $(Xlonelytest)
	$(COPY)  `echo $@ | sed -e s/$(testdir)/$(builddir)/ -e s/.Xsafe.pdf/-X.pdf/`  $@

$(Llonelypath): $(Llonelytest)
	$(COPY)  `echo $@ | sed -e s/$(testdir)/$(builddir)/ -e s/.Lsafe.pdf/-L.pdf/`  $@


#### TESTS FOR BOTH ENGINES ####

$(builddir)/F%-L.diff.pdf: $(builddir)/F%-L.pdf
	@echo 'F$*: Comparing PDF from LuaLaTeX against reference output.'
	if test $(shell compare \
	                $(COMPARE_OPTS) \
	                $(builddir)/F$*-L.pdf \
	                $(testdir)/F$*.Lsafe.pdf \
	                $(builddir)/F$*-L.diff.pdf 2>&1) -le 1 ; then \
	  echo 'F$*: Test passed.' ; \
	else \
	  echo 'F$*: Test failed.' ; \
	  false ; \
	fi

$(builddir)/F%-X.diff.pdf: $(builddir)/F%-X.pdf
	@echo 'F$*: Comparing PDF from XeLaTeX against reference output.'
	if test $(shell compare \
	                $(COMPARE_OPTS) \
	                $(builddir)/F$*-X.pdf \
	                $(testdir)/F$*.Xsafe.pdf \
	                $(builddir)/F$*-X.diff.pdf 2>&1) -le 1 ; then \
	  echo 'F$*: Test passed.' ; \
	else \
	  echo 'F$*: Test failed.' ; \
	  false ; \
	fi

$(builddir)/F%-L.pdf: $(BUILDSOURCE) $(BUILDSUITE) $(builddir)/F%-L.ltx
	@echo 'F$*: Generating PDF output with LuaLaTeX.'
	@cd $(builddir); lualatex -interaction=nonstopmode F$*-L.ltx  $(REDIRECT)

$(builddir)/F%-X.pdf: $(BUILDSOURCE) $(BUILDSUITE) $(builddir)/F%-X.ltx
	@echo 'F$*: Generating PDF output with XeLaTeX.'
	@cd $(builddir); xelatex -interaction=nonstopmode F$*-X.ltx   $(REDIRECT)

$(builddir)/F%-L.ltx: $(builddir)/F%.ltx
	$(COPY) $< $@

$(builddir)/F%-X.ltx: $(builddir)/F%.ltx
	$(COPY) $< $@


#### TEST FOR EACH ENGINE INDIVIDUALLY ####

$(builddir)/L%.diff.pdf: $(builddir)/L%.pdf
	@echo 'L$*: Comparing PDF against reference output.'
	if test $(shell compare $(COMPARE_OPTS) \
	          $(builddir)/L$*.pdf $(testdir)/L$*.safe.pdf \
	          $(builddir)/L$*.diff.pdf 2>&1) -le 1 ; then \
	  echo 'L$*: Test passed.' ; \
	else \
	  echo 'L$*: Test failed.' ; \
	  false ; \
	fi

$(builddir)/X%.diff.pdf: $(builddir)/X%.pdf
	@echo 'X$*: Comparing PDF against reference output.'
	if test $(shell compare \
	                $(COMPARE_OPTS) \
	                $(builddir)/X$*.pdf \
	                $(testdir)/X$*.safe.pdf \
	                $(builddir)/X$*.diff.pdf 2>&1) -le 1 ; then \
	  echo 'X$*: Test passed.' ; \
	else \
	  echo 'X$*: Test failed.' ; \
	  false ; \
	fi

$(builddir)/X%.pdf: $(BUILDSOURCE) $(BUILDSUITE) $(builddir)/X%.ltx
	@echo 'X$*: Generating PDF output with XeLaTeX.'
	@cd $(builddir); xelatex -interaction=nonstopmode X$*.ltx $(REDIRECT)

$(builddir)/L%.pdf: $(BUILDSOURCE) $(BUILDSUITE) $(builddir)/L%.ltx
	@echo 'L$*: Generating PDF output with LuaLaTeX.'
	@cd $(builddir); lualatex -interaction=nonstopmode L$*.ltx $(REDIRECT)

#### HACK: allow `make <foobar>` run that test.

L%: build/L%.ltx
	make build/L$*.diff.pdf

X%: build/X%.ltx
	make build/X$*.diff.pdf

F%: build/F%.ltx
	make build/F$*-L.diff.pdf
	make build/F$*-X.diff.pdf


###### NIGHTLY BUILDS ######

UNAME_S := $(shell uname -s)

# Mac OS X:
ifeq ($(UNAME_S),Darwin)
	MD5 = md5
endif

# Linux:
ifeq ($(UNAME_S),Linux)
	MD5 = md5sum
endif

BRANCH = tds-build

TDS = $(TDS_ZIP)
TMP = /tmp
LOG =  $(TMP)/gitlog.tmp


checkbranch:
	@if  git branch | grep $(BRANCH) > /dev/null ; \
	then echo "TDS branch exists"; \
	else \
	  echo "TDS branch does not exist; doing so will remove all untracked files from your working directory. Create the TDS branch with\n    make createbranch"; \
	  false; \
	fi;

createbranch: $(TDS)
	cp -f $(TDS) $(TMP)/
	git symbolic-ref HEAD refs/heads/$(BRANCH)
	rm .git/index
	git clean -fdx
	unzip -o $(TMP)/$(TDS) -d .
	rm $(TMP)/$(TDS)
	git add --all
	git commit -m "Initial TDS commit"
	git checkout master
	git push origin $(BRANCH) master
	@echo "\nTDS branch creation was successful.\n"
	@echo "Now create a new package at TLContrib: http://tlcontrib.metatex.org/"
	@echo "Use the following metadata:"
	@echo "    Package ID: $(NAME)"
	@echo "        BRANCH: $(BRANCH)"
	@echo "\nAfter this process, use \`make tdsbuild\` to"
	@echo "    (a) push your recent work on the master branch,"
	@echo "    (b) automatically create a TDS snapshot,"
	@echo "    (c) send the TDS snapshot to TLContrib."


ifeq ($(UNAME_S),Darwin)
  nightly:  USERNAME = $(shell security find-internet-password -s tlcontrib.metatex.org | grep "acct" | cut -f 4 -d \")
  nightly:  PASSWORD = $(shell security 2>&1 >/dev/null find-internet-password -gs tlcontrib.metatex.org | cut -f 2 -d ' ')
endif

ifeq ($(UNAME_S),Linux)
  nightly:  USERNAME = ""
  nightly:  PASSWORD = ""
endif

nightly:  VERSION = $(shell date "+%Y-%m-%d@%H:%M")

nightly:  CHECKSUM = $(shell echo $(USERNAME)/$(PASSWORD)/$(VERSION) | $(MD5) )

nightly: tdsbuild checkbranch checkpw
	@echo "Pushing TDS and master branch"

=== texmf-dist/source/latex/koma-script/Makefile ===
# ======================================================================
# Makefile
# Copyright (c) Markus Kohm, 2002-2013
#
# This file is part of the LaTeX2e KOMA-Script bundle.
#
# This work may be distributed and/or modified under the conditions of
# the LaTeX Project Public License, version 1.3c of the license.
# The latest version of this license is in
#   http://www.latex-project.org/lppl.txt
# and version 1.3c or later is part of all distributions of LaTeX 
# version 2005/12/01 or later and of this work.
#
# This work has the LPPL maintenance status "author-maintained".
#
# The Current Maintainer and author of this work is Markus Kohm.
#
# This work consists of all files listed in manifest.txt.
# ----------------------------------------------------------------------
# Makefile
# Copyright (c) Markus Kohm, 2002-2013
#
# Dieses Werk darf nach den Bedingungen der LaTeX Project Public Lizenz,
# Version 1.3c, verteilt und/oder veraendert werden.
# Die neuste Version dieser Lizenz ist
#   http://www.latex-project.org/lppl.txt
# und Version 1.3c ist Teil aller Verteilungen von LaTeX
# Version 2005/12/01 oder spaeter und dieses Werks.
#
# Dieses Werk hat den LPPL-Verwaltungs-Status "author-maintained"
# (allein durch den Autor verwaltet).
#
# Der Aktuelle Verwalter und Autor dieses Werkes ist Markus Kohm.
# 
# Dieses Werk besteht aus den in manifest.txt aufgefuehrten Dateien.
# ======================================================================

# ----------------------------------------------------------------------
# All directories with Makefiles
export BASEDIR ?= $(PWD)/
SUBDIRS = doc
# ----------------------------------------------------------------------
# Load common rules
include Makefile.baserules
# Load variable definitions
include Makefile.baseinit
# ----------------------------------------------------------------------
# Temporary folder, used to create distribution.
# Same folder with postfix "-maintain" will be used to create maintain-
# distribution.
export DISTDIR	   := $(PWD)/koma-script-$(ISODATE)
export MAINTAINDIR := $(DISTDIR)-maintain
# ----------------------------------------------------------------------

# ----------------------------------------------------------------------
# More than once used:
# Make implementation documentation
define makepdffromdtx
	if ! $(LATEX) $(NONSTOPMODE) $(PDFOUTPUT) $<; then \
	    $(RM) -v $@; \
	    exit 1; \
	fi
        oncemore=true; \
        checksum=`$(CKSUM) $(basename $<).aux`; \
        while $$oncemore; \
	do \
	    if ! $(MKINDEX) $(basename $<) \
	       || ! $(LATEX) $(NONSTOPMODE) $(PDFOUTPUT) $<; then \
	        $(RM) -v $@; \
	        exit 1; \
	    fi; \
	    $(GREP) Rerun $(basename $<).log || oncemore=false; \
	    newchecksum=`$(CKSUM) $(basename $<).aux`; \
	    [ "$$newchecksum"="$$checksum" ] || oncemore=true; \
	    checksum="$$newchecksum"; \
	done
endef
# ----------------------------------------------------------------------

# ----------------------------------------------------------------------
# List of all Makefiles
MAKE_FILES	= Makefile Makefile.baserules Makefile.baseinit
# ----------------------------------------------------------------------
# make classes, packages, etc.
CLS_MAIN	= scrbook.cls \
		  scrreprt.cls \
		  scrartcl.cls \
		  scrlttr2.cls \
		  typearea.sty \
		  scrsize10pt.clo \
		  scrsize11pt.clo \
		  scrsize12pt.clo \
		  scrlfile.sty \
	   	  scrwfile.sty \
		  scrbase.sty \
		  scrkbase.sty \
		  scraddr.sty \
		  scrpage2.sty \
		  scrtime.sty \
		  scrdate.sty \
		  scrjura.sty \
		  tocbasic.sty \
		  tocstyle.sty \
		  scrextend.sty \
		  scrhack.sty \
		  float.hak \
		  floatrow.hak \
		  hyperref.hak \
		  listings.hak \
		  scrfontsizes.sty \
		  visualize.lco \
	          DIN.lco \
		  DINmtext.lco \
		  SN.lco \
	 	  SNleft.lco \
		  KOMAold.lco \
		  NF.lco \
		  UScommercial9.lco \
		  UScommercial9DW.lco \
		  NipponEH.lco \
		  NipponEL.lco \
		  NipponLH.lco \
		  NipponLL.lco \
		  NipponRL.lco \
		  KakuLL.lco \
		  scrlayer.sty \
		  scrlayer-scrpage.sty \
		  scrlayer-notecolumn.sty

CLS_MAIN_DTX    = scrbeta.dtx \
		  scrkernel-basics.dtx \
		  scrkernel-bibliography.dtx \
		  scrkernel-circularletters.dtx \
		  scrkernel-compatibility.dtx \
		  scrkernel-floats.dtx \
		  scrkernel-fonts.dtx \
		  scrkernel-footnotes.dtx \
		  scrkernel-index.dtx \
		  scrkernel-language.dtx \
		  scrkernel-letterclassoptions.dtx \
		  japanlco.dtx \
		  scrkernel-listsof.dtx \
		  scrkernel-listsandtabulars.dtx \
		  scrkernel-miscellaneous.dtx \
		  scrkernel-notepaper.dtx \
		  scrkernel-pagestyles.dtx \
		  scrkernel-paragraphs.dtx \
		  scrkernel-pseudolengths.dtx \
		  scrkernel-sections.dtx \
		  scrkernel-typearea.dtx \
		  scrkernel-title.dtx \
		  scrkernel-variables.dtx \
		  scrkernel-version.dtx \
		  scrlfile.dtx \
		  scrwfile.dtx \
		  scraddr.dtx \
		  scrpage.dtx \
		  scrtime.dtx \
		  scrlogo.dtx \
	          scrextend.dtx \
                  scrhack.dtx \
		  scrjura.dtx \
		  tocbasic.dtx \
		  tocstyle.dtx \
		  scrlayer.dtx \
		  scrlayer-scrpage.dtx \
		  scrlayer-notecolumn.dtx

STATIC_DOC      = README \
	          INSTALL.txt \
		  INSTALLD.txt \
	          lppl.txt \
	          lppl-de.txt \
		  manifest.txt \
		  komabug.tex

CLS_MAIN_DVI	= scrsource.pdf

CLS_MAIN_INS	= scrmain.ins

CLS_MAIN_SUBINS	= scrstrip.inc scrstrop.inc scrdocstrip.tex

ALPHA_INS       = tocstyle.dtx scrjura.dtx scrwfile.dtx

ALPHA_DOC       = tocstyle.pdf scrjura.pdf scrhack.pdf

ALPHA_DTX       = $(subst .pdf,.dtx,$(ALPHA_DOC))

CLS_MAIN_SRC	= $(CLS_MAIN_DTX) $(CLS_MAIN_INS) $(CLS_MAIN_SUBINS) \
		  scrsource.tex

$(ALPHA_DOC): $(ALPHA_DTX)
	$(LATEX) $(BATCHMODE) $(PDFOUTPUT) $(subst .pdf,.dtx,$@)
	$(MKINDEX) $(subst .pdf,,$@)
	$(LATEX) $(BATCHMODE) $(PDFOUTPUT) $(subst .pdf,.dtx,$@)
	$(MKINDEX) $(subst .pdf,,$@)
	$(LATEX) $(BATCHMODE) $(PDFOUTPUT) $(subst .pdf,.dtx,$@)

$(CLS_MAIN): $(CLS_MAIN_DVI) $(CLS_MAIN_INS) $(MAKE_FILES)
	$(TEXUNPACK) $(CLS_MAIN_INS)
	$(foreach alphains,$(ALPHA_INS),$(TEXUNPACK) $(alphains);)

scrsource.pdf: scrsource.tex $(CLS_MAIN_DTX) $(MAKE_FILES) scrdoc.cls
	$(makepdffromdtx)

scrdoc.cls: scrdoc.dtx
	$(SSYMLINK) scrdoc.dtx scrdoc.cls

# ----------------------------------------------------------------------
CLS_FILES	= scrdoc.cls $(CLS_MAIN)

CLS_DVIS	= $(CLS_MAIN_DVI)

CLS_SRC		= $(CLS_MAIN_SRC)

NODIST_GENERATED = $(CLS_DVIS) $(CLS_FILES) $(ALPHA_DOC)

GENERATED	= $(NODIST_GENERATED) ChangeLog \
		  scrjura.ins \
		  scrwfile.ins scrwfile.tex scrwfile.drv \
		  tocbasic.ins tocbasic.tex \
	 	  tocstyle.ins tocstyle.tex tocstyle.dvi tocstyle.drv \
		  scrlayer.tex scrlayer-scrpage.tex scrlayer-notecolumn.tex

MISC_SRC	= $(MAKE_FILES) \
                  scrdoc.dtx ChangeLog ChangeLog.2

DIST_SRC	= $(MISC_SRC) $(CLS_SRC)

DIST_FILES	= $(DIST_SRC) $(STATIC_DOC) $(ALPHA_DOC)

MAINTAIN_SRC    = $(DIST_SRC) missing.dtx .cvsignore

MAINTAIN_FILES  = $(MAINTAIN_SRC)
# ----------------------------------------------------------------------

# ----------------------------------------------------------------------
# additional rules
tdsdist:dist
	# extract dist and make all
	$(UNTARGZ) $(DISTDIR).tar.gz
	chmod -R a+w $(DISTDIR)
ifdef PREPARERELEASE
	developer/scripts/preparerelease.sh 2 $(notdir $(DISTDIR))
endif
	$(CD) $(notdir $(DISTDIR)) && \
	  $(MAKE)
ifdef PREPARERELEASE
	$(MKDIR) $(notdir $(DISTDIR))/README.in
	$(INSTALL) README.in/README.*.sty README.in/README.*.cls $(notdir $(DISTDIR))/README.in
	developer/scripts/preparerelease.sh 3 $(notdir $(DISTDIR))
	$(RMDIR) $(notdir $(DISTDIR))/README.in
endif
	# install to temporary directory
	$(MKDIR) $(notdir $(DISTDIR))-bin/komascript-texmf
	$(CD) $(notdir $(DISTDIR)) && \
	  $(MAKE) INSTALLTEXMF=$(PWD)/$(notdir $(DISTDIR))-bin/komascript-texmf install
ifdef PREPARERELEASE
	developer/scripts/preparerelease.sh final $(notdir $(DISTDIR))
endif
	$(RMDIR) $(notdir $(DISTDIR))
	$(SRM) $(notdir $(DISTDIR))-bin/komascript-texmf/ls-R
	# build the tds.zip
	$(SRM) komascript.tds.zip
	$(CD) $(notdir $(DISTDIR))-bin/komascript-texmf && \
	  $(ZIP) ../../komascript.tds.zip source doc tex
	# clean up
	$(RMDIR) $(notdir $(DISTDIR))-bin
	$(SRM) $(notdir $(DISTDIR)).tar.gz

bindist:tdsdist
	# extract tds.zip
	$(MKDIR) $(notdir $(DISTDIR))-bin
	$(MKDIR) $(notdir $(DISTDIR))-bin/komascript-texmf
	$(CD) $(notdir $(DISTDIR))-bin/komascript-texmf && \
	  $(UNZIP) ../../komascript.tds.zip
	# copy some of the files to primary folder
	$(MV) komascript.tds.zip $(notdir $(DISTDIR))-bin/
	$(INSTALL) $(notdir $(DISTDIR))-bin/komascript-texmf/source/latex/koma-script/ChangeLog $(notdir $(DISTDIR))-bin
	$(INSTALL) $(notdir $(DISTDIR))-bin/komascript-texmf/doc/latex/koma-script/scrgui* $(notdir $(DISTDIR))-bin
	$(INSTALL) $(notdir $(DISTDIR))-bin/komascript-texmf/doc/latex/koma-script/*.txt $(notdir $(DISTDIR))-bin
	$(INSTALL) $(notdir $(DISTDIR))-bin/komascript-texmf/doc/latex/koma-script/README $(notdir $(DISTDIR))-bin
	$(INSTALL) $(notdir $(DISTDIR))-bin/komascript-texmf/doc/latex/koma-script/koma*.html $(notdir $(DISTDIR))-bin
	$(GREP) 'CheckKOMAScriptVersion{' $(notdir $(DISTDIR))-bin/komascript-texmf/source/latex/koma-script/scrkernel-version.dtx | grep -o '2.*t' > $(notdir $(DISTDIR))-bin/VERSION
	# build the bin.zip
	$(RMDIR) $(notdir $(DISTDIR))-bin/komascript-texmf
	$(SRM) $(notdir $(DISTDIR))-bin.zip
	$(CD) $(notdir $(DISTDIR))-bin && \
	  $(ZIP) ../$(notdir $(DISTDIR))-bin.zip *
	# clean up
	$(RMDIR) $(notdir $(DISTDIR))-bin

ctandist:tdsdist
	# extract tds.zip
	$(SRMDIR) $(notdir $(DISTDIR))-ctan
	$(MKDIR) $(notdir $(DISTDIR))-ctan/texmf
	$(INSTALL) komascript.tds.zip $(notdir $(DISTDIR))-ctan
	$(CD) $(notdir $(DISTDIR))-ctan/texmf && \
	  $(UNZIP) ../komascript.tds.zip
	# copy some doc files to doc source
	$(INSTALL) $(notdir $(DISTDIR))-ctan/texmf/doc/latex/koma-script/*.html \
	  $(notdir $(DISTDIR))-ctan/texmf/doc/latex/koma-script/*.pdf \
	  $(notdir $(DISTDIR))-ctan/texmf/source/latex/koma-script/doc/
	# copy some doc files to main source
	$(INSTALL) $(notdir $(DISTDIR))-ctan/texmf/doc/latex/koma-script/*.txt \
	  $(notdir $(DISTDIR))-ctan/texmf/doc/latex/koma-script/*.tex \
	  $(notdir $(DISTDIR))-ctan/texmf/doc/latex/koma-script/README \
	  $(notdir $(DISTDIR))-ctan/texmf/source/latex/koma-script/
	# generate VERSION at main source
	$(GREP) 'CheckKOMAScriptVersion{' $(notdir $(DISTDIR))-ctan/texmf/source/latex/koma-script/scrkernel-version.dtx | grep -o '2.*t' \
	  > $(notdir $(DISTDIR))-ctan/texmf/source/latex/koma-script/VERSION
	# generate README.distributors at upmost
	$(HEAD) 18 $(notdir $(DISTDIR))-ctan/texmf/source/latex/koma-script/README > $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) 'File komascript.tds.zip is a complete TEXMF tree of KOMA-Script.  It may be' >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) 'used for manual installation or by distributors for distributions like' >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) '<http://www.ctan.org/tex-archive/install/macros/latex/contrib/komascript.tds.zip>.' >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) "File $(notdir $(DISTDIR)).ctan-src.zip is a file with sources and manuals of KOMA-Script"  >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) 'that CTAN seems to prefer for the distribution at'  >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) '<http://www.ctan.org/tex-archive/macros/latex/contrib/komascript>.' >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) 'Note, that it is not easy to generate a ready to use and complete installation' >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) "from $(notdir $(DISTDIR)).ctan-src.zip.  So it is hardly recommended to use" >> $(notdir $(DISTDIR))-ctan/README.distributors
	$(SECHO) 'komascript.tds.zip not only by users, but redistributors also.' >> $(notdir $(DISTDIR))-ctan/README.distributors
	# build ctan-src.zip
	$(CD) $(notdir $(DISTDIR))-ctan/texmf/source/latex && \

=== texmf-dist/source/latex/otibet/Makefile ===
#
# gnumakefile
#
SHELL=/bin/bash
OTPDIR=../otp
OCPDIR=../ocp
OCPS=tibinwylie.ocp tibinunicode.ocp tibadjusttsheg.ocp tibuniuni.ocp tibvowel.ocp tibout.ocp tibspecial.ocp

# vpath
vpath %.otp $(OTPDIR)
vpath %.ocp $(OCPDIR)

export OCPINPUTS=$(OCPDIR):
export DESTROOT=.

# implicit rules
%.ocp : %.otp
	cd ../otp ; make $*.ocp

%.ps : %.odvi
	odvips $*.odvi

%.dvi : %.odvi
	odvicopy $*.odvi $*.dvi

first: allbasic.dvi

yugpacan: yugpacan.ps yugpacan.dvi
unidoc: unidoc.ps unidoc.dvi
tiblatex: tiblatex.ps tiblatex.dvi
allbasic: allbasic.ps allbasic.dvi

all: unidoc tiblatex yugpacan allbasic 

tiblatex.odvi: tiblatex.tex $(OCPS) otibet.sty otibet.tex
	lambda ./tiblatex.tex
	mv tiblatex.dvi tiblatex.odvi

yugpacan.odvi: yugpacan.tex $(OCPS) otibet.sty otibet.tex
	lambda ./yugpacan.tex
	mv yugpacan.dvi yugpacan.odvi

unidoc.odvi: unidoc.tex $(OCPS) otibet.sty otibet.tex
	lambda  ./unidoc.tex
	lambda  ./unidoc.tex
	mv unidoc.dvi unidoc.odvi

allbasic.odvi: allbasic.tex $(OCPS) otibet.sty otibet.tex
	lambda ./allbasic.tex
	mv allbasic.dvi allbasic.odvi

clean:
	rm -f *.odvi *.dvi *.aux *.log *.ps *~ 

# eof

=== texmf-dist/source/luatex/lualibs/Makefile ===
# Makefile for lualibs.

NAME = lualibs
DTX = $(wildcard *.dtx)
DOC_DTX = $(patsubst %.dtx, %.pdf, $(DTX))
LUALIBS	= $(wildcard lualibs-*.lua)
MODULES = $(filter-out $(UNPACKED),$(LUALIBS))

# Files grouped by generation mode
TESTSCRIPT 		= test-lualibs.lua
DIFFSCRIPT 		= whatsnew.lua
SCRIPTS			= $(TESTSCRIPT) $(DIFFSCRIPT)
UNPACKED		= lualibs.lua lualibs-extended.lua lualibs-basic.lua
COMPILED 		= $(DOC_DTX)
GENERATED 		= $(UNPACKED) $(DOC_DTX) $(MERGED)
SOURCE 			= $(DTX) $(MODULES) $(SCRIPTS) LICENSE README Makefile NEWS
MERGED 			= lualibs-basic-merged.lua lualibs-extended-merged.lua

# Files grouped by installation location
RUNFILES = $(UNPACKED) $(MODULES)
DOCFILES = $(DOC_DTX) LICENSE README NEWS
SRCFILES = $(DTX) $(SRC_TEX) Makefile $(SCRIPTS)

# The following definitions should be equivalent
# ALL_FILES = $(RUNFILES) $(DOCFILES) $(SRCFILES)
ALL_FILES = $(SOURCE) $(filter-out $(SOURCE),$(GENERATED))

# Installation locations
FORMAT = luatex
RUNDIR = $(TEXMFROOT)/tex/$(FORMAT)/$(NAME)
DOCDIR = $(TEXMFROOT)/doc/$(FORMAT)/$(NAME)
SRCDIR = $(TEXMFROOT)/source/$(FORMAT)/$(NAME)
DISTDIR = ./lualibs
TEXMFROOT = ./texmf

CTAN_ZIP = $(NAME).zip
TDS_ZIP = $(NAME).tds.zip
ZIPS = $(CTAN_ZIP) $(TDS_ZIP)

DO_TEX 			= luatex     --interaction=batchmode $< >/dev/null
DO_PDFLATEX 	= latexmk -pdf -e '$$pdflatex = q(lualatex %O %S)' -silent $< >/dev/null
DO_MAKEINDEX 	= makeindex  -s gind.ist $(subst .dtx,,$<) >/dev/null 2>&1
DO_PACKAGE 		= mtxrun     --script package --merge $< >/dev/null

all: $(GENERATED) $(DOC_TEX)
doc: $(COMPILED)
unpack: $(UNPACKED)
ctan: check $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

check: $(TESTSCRIPT)
	@texlua $(TESTSCRIPT)

news: $(DIFFSCRIPT)
	@texlua $(DIFFSCRIPT)

.PHONY: all doc unpack ctan tds world check news

%.pdf: %.dtx
	$(DO_PDFLATEX)
	$(DO_MAKEINDEX)
	$(DO_PDFLATEX)
	$(DO_PDFLATEX)

%-merged.lua: %.lua
	$(DO_PACKAGE)

$(UNPACKED): lualibs.dtx
	$(DO_TEX)

define make-ctandir
@if [ -d $(DISTDIR) ] ; \
 then \
     rm -r $(DISTDIR) ; \
 fi
@mkdir $(DISTDIR) && cp $(ALL_FILES) $(DISTDIR)
endef

$(CTAN_ZIP): $(ALL_FILES) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	$(make-ctandir)
	@zip -r -9 $@ $(DISTDIR) $(TDS_ZIP) >/dev/null

define run-install
@mkdir -p $(RUNDIR) && cp $(RUNFILES) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCFILES) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCFILES) $(SRCDIR)
endef

$(TDS_ZIP): TEXMFROOT=./tmp-texmf
$(TDS_ZIP): $(ALL_FILES)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	$(run-install)
	@cd $(TEXMFROOT) && zip -9 ../$@ -r . >/dev/null
	@$(RM) -r -- $(TEXMFROOT)

.PHONY: install manifest clean mrproper

install: $(ALL_FILES)
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

manifest: 
	@echo "Source files:"
	@for f in $(SOURCE); do echo $$f; done
	@echo ""
	@echo "Derived files:"
	@for f in $(GENERATED); do echo $$f; done

clean: 
	@$(RM) -- *.log *.aux *.toc *.idx *.ind *.ilg

mrproper: clean
	@$(RM) -- $(GENERATED) $(ZIPS)
	@$(RM) -r $(DISTDIR)

merge: $(MERGED)

=== texmf-dist/source/luatex/luamplib/Makefile ===
NAME      = luamplib
FORMAT    = luatex

DTX       = $(NAME).dtx
DOC       = $(NAME).pdf
STY       = $(NAME).sty
LUA       = $(NAME).lua
TEST      = test-$(NAME)-plain.tex test-$(NAME)-latex.tex

UNPACKED  = $(STY) $(LUA)
GENERATED = $(UNPACKED) $(DOC)
SOURCES   = $(DTX) README NEWS Makefile $(TEST)

DOCFILES  = $(DOC) $(TEST) README NEWS
SRCFILES  = $(DTX) Makefile
RUNFILES  = $(STY) $(LUA)

ALL       = $(SRCFILES) $(DOCFILES) $(RUNFILES)

TEXMFDIR  = ./texmf
RUNDIR    = $(TEXMFDIR)/tex/$(FORMAT)/$(NAME)
DOCDIR    = $(TEXMFDIR)/doc/$(FORMAT)/$(NAME)
SRCDIR    = $(TEXMFDIR)/source/$(FORMAT)/$(NAME)

CTAN_ZIP  = $(NAME).zip
TDS_ZIP   = $(NAME).tds.zip
ZIPS      = $(CTAN_ZIP) $(TDS_ZIP)

all: $(GENERATED)
doc: $(DOC)
unpack: $(UNPACKED)
ctan: check $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

.PHONY: all doc unpack ctan tds check world

%.pdf: %.dtx
	latexmk -lualatex -recorder- -silent $< >/dev/null

$(UNPACKED): $(DTX)
	luatex -interaction=batchmode $< >/dev/null

check: $(UNPACKED)
	luatex   -interaction=batchmode test-$(NAME)-plain.tex  >/dev/null
	lualatex -interaction=batchmode test-$(NAME)-latex.tex  >/dev/null
	! grep "blank space"              test-$(NAME)-plain.log
	! grep "blank space"              test-$(NAME)-latex.log

$(CTAN_ZIP): $(SOURCES) $(DOC) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	@mkdir -p $(NAME)
	@cp -f $(SOURCES) $(DOC) $(NAME)
	@zip -9 -r $@ $(TDS_ZIP) $(NAME) >/dev/null
	@rm -rf $(NAME)

define run-install
@mkdir -p $(RUNDIR) && cp $(RUNFILES) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCFILES) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCFILES) $(SRCDIR)
endef

$(TDS_ZIP): TEXMFDIR=./tmp-texmf
$(TDS_ZIP): $(ALL)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	@if test -e $(TEXMFDIR); then echo 'bad TEXMFDIR'; false; fi
	$(run-install)
	@cd $(TEXMFDIR) && zip -q -9 ../$@ -r .
	@$(RM) -r -- $(TEXMFDIR)

.PHONY: install clean mrproper help

install: check $(ALL)
	@echo "Installing in '$(TEXMFDIR)'."
	$(run-install)

clean:
	@latexmk -silent -c $(DTX) *.tex >/dev/null
	@rm -f -- *.log test*.pdf

mrproper: clean
	@rm -f -- $(GENERATED) $(ZIPS)

help:
	@echo '$(NAME) makefile targets:'
	@echo '                      help - (this message)'
	@echo '                       all - (default target) all generated files'
	@echo '                     world - synonymous for ctan'
	@echo '                    unpack - extract all files'
	@echo '                       doc - compile documentation'
	@echo '                      ctan - run check & generate archive for CTAN'
	@echo '                       tds - generate a TDS compliant archive'
	@echo '                     check - run the test files'
	@echo '   install TEXMFDIR=<path> - install in <path>'

=== texmf-dist/source/luatex/luaotfload/Makefile ===
# Makefile for luaotfload

NAME         = luaotfload
DOC          = $(NAME).pdf
DTX          = $(NAME).dtx
OTFL         = $(wildcard luaotfload-*.lua) luaotfload-blacklist.cnf

GLYPHSCRIPT  = mkglyphlist
GLYPHSOURCE  = glyphlist.txt
CHARSCRIPT   = mkcharacters
STATUSSCRIPT = mkstatus

RESOURCESCRIPTS = $(GLYPHSCRIPT) $(CHARSCRIPT) $(STATUSSCRIPT)

SCRIPTNAME   = luaotfload-tool
SCRIPT       = $(SCRIPTNAME).lua
MANSOURCE	 = $(SCRIPTNAME).rst
MANPAGE   	 = $(SCRIPTNAME).1
OLDSCRIPT    = luaotfload-legacy-tool.lua

GRAPH  		 = filegraph
DOTPDF 		 = $(GRAPH).pdf
DOT    		 = $(GRAPH).dot

# Files grouped by generation mode
GLYPHS      = luaotfload-glyphlist.lua
CHARS       = luaotfload-characters.lua
STATUS      = luaotfload-status.lua
RESOURCES	= $(GLYPHS) $(CHARS) $(STATUS)
GRAPHED     = $(DOTPDF)
MAN			= $(MANPAGE)
COMPILED    = $(DOC)
UNPACKED    = luaotfload.sty luaotfload.lua
GENERATED   = $(GRAPHED) $(UNPACKED) $(COMPILED) $(RESOURCES) $(MAN)
SOURCE 		= $(DTX) $(MANSOURCE) $(OTFL) README Makefile NEWS $(RESOURCESCRIPTS)

# test files
TESTDIR 		= tests
TESTSTATUS 		= $(wildcard $(TESTDIR)/*.tex $(TESTDIR)/*.ltx)
TESTSTATUS_SYS 	= $(TESTDIR)/systemfonts.tex $(TESTDIR)/fontconfig_conf_reading.tex
TESTSTATUS_TL 	= $(filter-out $(TESTSTATUS_SYS), $(TESTSTATUS))

# Files grouped by installation location
SCRIPTSTATUS = $(SCRIPT) $(OLDSCRIPT) $(RESOURCESCRIPTS)
RUNSTATUS    = $(UNPACKED) $(filter-out $(SCRIPTSTATUS),$(OTFL))
DOCSTATUS    = $(DOC) $(DOTPDF) README NEWS
MANSTATUS	= $(MANPAGE)
SRCSTATUS    = $(DTX) Makefile

# The following definitions should be equivalent
# ALL_STATUS = $(RUNSTATUS) $(DOCSTATUS) $(SRCSTATUS)
ALL_STATUS = $(GENERATED) $(SOURCE)

# Installation locations
FORMAT = luatex
SCRIPTDIR = $(TEXMFROOT)/scripts/$(NAME)
RUNDIR    = $(TEXMFROOT)/tex/$(FORMAT)/$(NAME)
DOCDIR    = $(TEXMFROOT)/doc/$(FORMAT)/$(NAME)
MANDIR    = $(TEXMFROOT)/doc/man/man1/
SRCDIR    = $(TEXMFROOT)/source/$(FORMAT)/$(NAME)
TEXMFROOT = $(shell kpsewhich --var-value TEXMFHOME)

# CTAN-friendly subdirectory for packaging
DISTDIR	  = ./luaotfload

CTAN_ZIP = $(NAME).zip
TDS_ZIP  = $(NAME).tds.zip
ZIPS 	 = $(CTAN_ZIP) $(TDS_ZIP)

LUA	= texlua

DO_TEX 		  	= luatex --interaction=batchmode $< >/dev/null
DO_LATEXMK	 	= latexmk -e '$$max_repeat = 5' -pdf -lualatex -silent $< >/dev/null
# latexmk does only one run on my machine, so we’re not going to rely on it
DO_LATEX  	 	= lualatex -interaction=batchmode $< >/dev/null
DO_GRAPHVIZ 	= dot -Tpdf -o $@ $< > /dev/null
DO_GLYPHS 		= $(LUA) $(GLYPHSCRIPT) > /dev/null
DO_CHARS 		= $(LUA) $(CHARSCRIPT)  > /dev/null
DO_STATUS 		= $(LUA) $(STATUSSCRIPT)  > /dev/null
DO_DOCUTILS 	= rst2man $< >$@ 2>/dev/null

all: $(GENERATED)
graph: $(GRAPHED)
doc: $(GRAPHED) $(COMPILED) $(MAN)
manual: $(MAN)
unpack: $(UNPACKED)
resources: $(RESOURCES)
chars: $(CHARS)
status: $(STATUS)
ctan: $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

$(GLYPHS): /dev/null
	$(DO_GLYPHS)

$(CHARS): /dev/null
	$(DO_CHARS)

$(STATUS): /dev/null
	$(DO_STATUS)

$(GRAPHED): $(DOT)
	$(DO_GRAPHVIZ)

$(COMPILED): $(DTX)
	$(DO_LATEX)
	$(DO_LATEX)

$(UNPACKED): $(DTX)
	$(DO_TEX)

$(MAN): $(MANSOURCE)
	$(DO_DOCUTILS)

define make-ctandir
@$(RM) -rf $(DISTDIR)
@mkdir -p $(DISTDIR) && cp $(SOURCE) $(COMPILED) $(DISTDIR)
endef

$(CTAN_ZIP): $(SOURCE) $(COMPILED) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	$(make-ctandir)
	@zip -r -9 $@ $(TDS_ZIP) $(DISTDIR) >/dev/null

define run-install
@mkdir -p $(SCRIPTDIR) && cp $(SCRIPTSTATUS) $(SCRIPTDIR)
@mkdir -p $(RUNDIR) && cp $(RUNSTATUS) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCSTATUS) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCSTATUS) $(SRCDIR)
@mkdir -p $(MANDIR) && cp $(MANSTATUS) $(MANDIR)
endef

$(TDS_ZIP): TEXMFROOT=./tmp-texmf
$(TDS_ZIP): $(ALL_STATUS)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	$(run-install)
	@cd $(TEXMFROOT) && zip -9 ../$@ -r . >/dev/null
	@$(RM) -r -- $(TEXMFROOT)

.PHONY: install manifest clean mrproper

install: $(ALL_STATUS)
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

check: $(RUNSTATUS) $(TESTSTATUS_TL)
	@rm -rf var
	@for f in $(TESTSTATUS_TL); do \
	    echo "check: luatex $$f"; \
	    luatex --interaction=batchmode $$f \
	    > /dev/null || exit $$?; \
	    done

check-all: $(TESTSTATUS_SYS) check
	@cd $(TESTDIR); for f in $(TESTSTATUS_SYS); do \
	    echo "check: luatex $$f"; \
	    $(TESTENV) luatex --interaction=batchmode ../$$f \
	    > /dev/null || exit $$?; \
	    done

manifest: 
	@echo "Source files:"
	@for f in $(SOURCE); do echo $$f; done
	@echo ""
	@echo "Derived files:"
	@for f in $(GENERATED); do echo $$f; done

clean: 
	@$(RM) -- *.log *.aux *.toc *.idx *.ind *.ilg *.out $(TESTDIR)/*.log

mrproper: clean
	@$(RM) -- $(GENERATED) $(ZIPS) $(GLYPHSOURCE) $(TESTDIR)/*.pdf
	@$(RM) -r -- $(DISTDIR)

=== debian/changelog ===
texlive-base (2013.20140215-1ubuntu0.1) trusty-security; urgency=medium

  * SECURITY UPDATE: execute arbitrary commands
    - debian/patches/CVE-2016-10243.patch: fixes tex arbitrary code
      execution by removing mpost in texmf/web2c/texmf.cnf.
    - CVE-2016-10243

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 21 Aug 2017 16:44:17 -0300

texlive-base (2013.20140215-1) unstable; urgency=medium

  * new upstream checkout
  * fix dash/bash inconsistency in texlive-base.postinst.post (Closes: #736520)
  * remove some patches included upstream

 -- Norbert Preining <preining@debian.org>  Sat, 15 Feb 2014 11:23:23 +0900

texlive-base (2013.20140123-1) unstable; urgency=medium

  * new upstream checkout
  * t-pictures: changes wish -> tk (Closes: #732784)
  * tighten build-dep on tex-common to >= 4 (Closes: #733414)

 -- Norbert Preining <preining@debian.org>  Thu, 23 Jan 2014 13:12:37 +0900

texlive-base (2013.20131219-1) unstable; urgency=medium

  * new upstream checkout
  * add lost link for /usr/bin/texdoctk, thanks R S Chakravarti.
  * remove left-over config-paper file for dvipdfm (Closes: #731446)
  * bump standards version, no changes necessary

 -- Norbert Preining <preining@debian.org>  Thu, 19 Dec 2013 13:43:58 +0900

texlive-base (2013.20131112-1) unstable; urgency=low

  * new upstream checkout
  * fix wrong lua2dox_filter symlink (Closes: #726793)
  * update patches
  * update tlmgr to devel version to make it actually work

 -- Norbert Preining <preining@debian.org>  Wed, 13 Nov 2013 12:01:14 +0900

texlive-base (2013.20131010-2) unstable; urgency=low

  * fix libpaper integration (outdated path in conffile) (Closes: #726107)
  * remove xdvi.cfg conffile from old versions (Closes: #726076)

 -- Norbert Preining <preining@debian.org>  Wed, 16 Oct 2013 09:26:53 +0900

texlive-base (2013.20131010-1) unstable; urgency=low

  * new upstream checkout

 -- Norbert Preining <preining@debian.org>  Thu, 10 Oct 2013 12:35:27 +0900

texlive-base (2013.20130918-1) unstable; urgency=low

  * new upstream checkout
  * remove !! from TEXMFSYSCONFIG, we don't want ls-R files in /etc/texmf
    (Closes: #722689)

 -- Norbert Preining <preining@debian.org>  Wed, 18 Sep 2013 12:40:03 +0900

texlive-base (2013.20130905-1) unstable; urgency=low

  * new upstream checkout
    - don't ship strange duplicates of Nimbus Sans (Closes: #690125)
  * remove /etc/texmf/dvipdfm/config/config (Closes: #713797)
  * do not ship marvosym.ttf via dependency (Closes: #721716)
  * bump standards version to 3.9.4, no changes necessary
  * fix man section of updmap.cfg man page
  * fix man page of mptopdf
  * stop shipping TeX Gyre Math fonts, they are in tex-gyre package

 -- Norbert Preining <preining@debian.org>  Thu, 05 Sep 2013 11:46:27 +0900

=== debian/control ===
Source: texlive-base
Section: tex
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian TeX Maintainers <debian-tex-maint@lists.debian.org>
Uploaders: Norbert Preining <preining@debian.org>, Frank Küster <frank@debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: sharutils, tex-common (>= 4), eperl, findutils (>=4.2.0)
Standards-Version: 3.9.5
Homepage: http://www.tug.org/texlive/

Package: texlive-base
Architecture: all
Depends: tex-common (>= 4.03), xdg-utils, ${misc:Depends}, luatex (>= 0.70.1), ucf, texlive-binaries (>= 2013.20130512), libpaper-utils
Conflicts: texlive-plain-extra (<< 2013.20130512), texlive-lang-armenian (<< 2013.20130512), texlive-doc-fi (<< 2013), texlive-doc-tr (<< 2013.20130512), texlive-latex-extra-doc (<< 2013.20130512), texlive-fonts-recommended (<< 2013.20130512), texlive-science-doc (<< 2013.20130512), texlive-doc-it (<< 2013.20130512), texlive-lang-german (<< 2013.20130512), texlive-doc-ko (<< 2013.20130512), texlive-lang-finnish (<< 2013.20130512), texlive-doc-rs (<< 2013), texlive-lang-other (<< 2013.20130512), texlive-lang-norwegian (<< 2013), texlive-doc-vi (<< 2013.20130512), texlive-lang-mongolian (<< 2013.20130512), texlive-doc-ar (<< 2013), texlive-doc-nl (<< 2013), texlive-doc-si (<< 2013.20130512), texlive-science (<< 2013.20130512), texlive-lang-hungarian (<< 2013), texlive-doc-uk (<< 2013.20130512), texlive-doc-rs (<< 2013.20130512), texlive-common, pdfjam (<< 2013.20130512), texlive-doc-vi (<< 2013), texlive-lang-vietnamese (<< 2013.20130512), texlive-extra-utils (<< 2013.20130512), texlive-doc-pl (<< 2013.20130512), texlive-lang-vietnamese (<< 2013), texlive-doc-ru (<< 2013.20130512), texlive-doc-ja (<< 2013), texlive-lang-polish (<< 2013.20130512), texlive-lang-african (<< 2013.20130512), texlive-lang-norwegian (<< 2013.20130512), texlive-doc-uk (<< 2013), texlive-humanities-doc (<< 2013.20130512), texlive-doc-ko (<< 2013), texlive-doc-zh (<< 2013), texlive-doc-bg (<< 2013.20130512), texlive-lang-spanish (<< 2013.20130512), ptex-bin (<< 2013.20130512), texlive-doc-si (<< 2013), texlive-lang-latvian (<< 2013), texlive-lang-dutch (<< 2013.20130512), texlive-doc-ja (<< 2013.20130512), texlive-pictures-doc (<< 2013.20130512), texlive-formats-extra (<< 2013.20130512), texlive-doc-pl (<< 2013), texlive-doc-tr (<< 2013), texlive-lang-hebrew (<< 2013), thailatex (<< 2013.20130512), texlive-lang-english (<< 2013.20130512), texlive-lang-indic (<< 2013.20130512), texlive-doc-ar (<< 2013.20130512), texlive-lang-swedish (<< 2013.20130512), texlive-base (<< 2013.20130512), texlive-doc-fr (<< 2013.20130512), texlive-pstricks-doc (<< 2013.20130512), texpower (<< 2013.20130512), texlive-doc-bg (<< 2013), texlive-publishers (<< 2013.20130512), texlive-lang-latin (<< 2013), texlive-games (<< 2013.20130512), texlive-humanities (<< 2013.20130512), texlive-publishers-doc (<< 2013.20130512), texlive-doc-pt (<< 2013.20130512), texlive-lang-dutch (<< 2013), texlive-omega (<< 2013.20130512), texlive-doc-mn (<< 2013.20130512), texlive-doc-it (<< 2013), texlive-fonts-recommended-doc (<< 2013.20130512), texlive-lang-cyrillic (<< 2013.20130512), texlive-xetex (<< 2013.20130512), texlive-pictures (<< 2013.20130512), texlive-pstricks (<< 2013.20130512), texlive-doc-base, texlive-lang-greek (<< 2013.20130512), texlive-generic-extra (<< 2013.20130512), texlive-doc-th (<< 2013), texlive-lang-danish (<< 2013), texlive-latex-recommended (<< 2013.20130512), texlive-full (<< 2013.20130512), texlive-latex3 (<< 2013.20130512), texlive-math-extra (<< 2013.20130512), texlive-fonts-extra-doc (<< 2013.20130512), texlive-latex-base-doc (<< 2013.20130512), texlive-metapost-doc (<< 2013.20130512), texlive-lang-arabic (<< 2013.20130512), texlive (<< 2013.20130512), texlive-lang-all (<< 2013.20130512), texlive-lang-croatian (<< 2013), texlive-doc-fi (<< 2013.20130512), texlive-doc-en (<< 2013.20130512), texlive-doc-cs+sk (<< 2013), texlive-lang-danish (<< 2013.20130512), texlive-lang-czechslovak (<< 2013.20130512), texlive-lang-french (<< 2013.20130512), texlive-music (<< 2013.20130512), texlive-doc-th (<< 2013.20130512), texlive-lang-lithuanian (<< 2013.20130512), texlive-lang-italian (<< 2013.20130512), texlive-latex-base (<< 2013.20130512), texlive-doc-zh (<< 2013.20130512), texlive-lang-lithuanian (<< 2013), texlive-latex-extra (<< 2013.20130512), texlive-lang-portuguese (<< 2013.20130512), texlive-lang-european (<< 2013.20130512), texlive-lang-swedish (<< 2013), texlive-doc-en (<< 2013), texlive-bibtex-extra (<< 2013.20130512), texlive-lang-armenian (<< 2013), texlive-lang-tibetan (<< 2013.20130512), texlive-doc-fr (<< 2013), texlive-doc-ru (<< 2013), texlive-doc-de (<< 2013.20130512), texlive-lang-hungarian (<< 2013.20130512), texlive-latex-recommended-doc (<< 2013.20130512), texlive-binaries (<< 2013.20130512), texlive-doc-cs+sk (<< 2013.20130512), texlive-doc-de (<< 2013), texlive-doc-mn (<< 2013), texlive-doc-es (<< 2013), texlive-lang-finnish (<< 2013), texlive-font-utils (<< 2013.20130512), texlive-lang-tibetan (<< 2013), texlive-luatex (<< 2013.20130512), texlive-doc-nl (<< 2013.20130512), texlive-metapost (<< 2013.20130512), texlive-fonts-extra (<< 2013.20130512), texlive-lang-mongolian (<< 2013), texlive-lang-croatian (<< 2013.20130512), texlive-doc-pt (<< 2013), texlive-lang-latvian (<< 2013.20130512), texlive-lang-cjk (<< 2013.20130512), texlive-lang-latin (<< 2013.20130512), texlive-lang-hebrew (<< 2013.20130512), texlive-doc-es (<< 2013.20130512), texlive-generic-recommended (<< 2013.20130512)
Recommends: lmodern (>= 0.93.3)
Provides: dvipdfmx
Suggests: ghostscript, gv | postscript-viewer, xpdf-reader | pdf-viewer, perl-tk
Replaces: context (<< 2012.05.30.20121209), texlive-binaries (<< 2013), texlive-doc-en (<< 2013), texlive-common (<< 2013)
Breaks: context (<< 2012.05.30.20121209)
Description: TeX Live: Essential programs and files
 These files are regarded as basic for any TeX system, covering plain TeX
   macros, Computer Modern fonts, and configuration for common drivers; no
   LaTeX.
 .
 This package includes the following CTAN packages:
  texlive.infra -- basic TeX Live infrastructure
  amsfonts -- TeX fonts from the American Mathematical Society.
  bibtex -- Process bibliographies for LaTeX, etc.
  cm -- Computer Modern fonts.
  dvipdfmx -- An extended version of dvipdfm.
  dvipdfmx-def -- Configuration file for dvipdfmx graphics.
  dvips -- A DVI to PostScript driver.
  enctex -- A TeX extension that translates input on its way into TeX.
  etex -- An extended version of TeX, from the NTS project.
  etex-pkg -- E-TeX support package.
  glyphlist --
  gsftopk -- Convert "ghostscript fonts" to PK files.
  hyph-utf8 -- Hyphenation patterns expressed in UTF-8.
  hyphen-base --
  ifluatex -- Provides the \ifluatex switch.
  ifxetex -- Am I running under XeTeX?
  knuth-lib -- A small library of MetaFont sources.
  knuth-local -- Knuth's local information.
  kpathsea -- Path searching library for TeX-related files.
  lua-alt-getopt -- Process application arguments the same way as
   getopt_long.
  luatex -- The LuaTeX engine.
  makeindex -- Process index output to produce typesettable code.
  metafont -- A system for specifying fonts.
  mflogo -- LaTeX support for Metafont logo fonts.
  mfware -- Supporting tools for use with Metafont.
  misc --
  pdftex -- A TeX extension for direct creation of PDF.
  plain --
  tetex -- scripts and files originally written for or included in teTeX
  tex -- A sophisticated typesetting engine.
  texconfig --
  texlive-common -- TeX Live documentation (common elements)
  texlive-docindex -- top-level TeX Live doc.html, etc.
  texlive-en -- TeX Live manual (English)
  xdvi -- A DVI previewer for the X Window System.
  texdoc -- Documentation access for TeX distributions.

Package: texlive-generic-recommended
Architecture: all
Depends: ${misc:Depends}, texlive-base (>= 2013.20130512), texlive-base (>= 2013.20130512)
Description: TeX Live: Generic recommended packages
 Recommended packages that work with multiple formats.
 .
 This package includes the following CTAN packages:
  epsf -- Simple macros for EPS inclusion.
  fontname -- Scheme for naming fonts in TeX.
  genmisc --
  kastrup --
  multido -- A loop facility for Generic TeX.
  path -- Typeset paths, making them breakable.
  tex-ps -- TeX to PostScript generic macros and add-ons.
  ulem -- Package for underlining.

Package: texlive-latex-base
Architecture: all
Depends: texlive-binaries (>= 2013.20130512), texlive-base (>= 2013.20130512), texlive-base (>= 2013.20130512), ${misc:Depends}
Recommends: texlive-latex-base-doc
Description: TeX Live: LaTeX fundamental packages
 These packages are mandated by the core LaTeX team, or at least very
   strongly recommended.
 .
 This package includes the following CTAN packages:
  ae -- Virtual fonts for T1 encoded CMR-fonts.
  amscls -- AMS document classes for LaTeX.
  amsmath -- AMS mathematical facilities for LaTeX.
  babel -- Multilingual support for Plain TeX or LaTeX.
  babel-english --
  babelbib -- Multilingual bibliographies.
  carlisle -- David Carlisle's small packages.
  colortbl -- Add colour to LaTeX tables.
  fancyhdr -- Extensive control of page headers and footers in LaTeX2e.
  fix2col -- Fix miscellaneous two column mode features.
  geometry -- Flexible and complete interface to document dimensions.
  graphics -- Standard LaTeX graphics.
  hyperref -- Extensive support for hypertext in LaTeX.
  latex -- A TeX macro package that defines LaTeX.
  latex-bin -- LaTeX executables and man pages.
  latex-fonts -- A collection of fonts used in LaTeX distributions.
  latexconfig --
  ltxmisc -- Miscellaneous LaTeX packages, etc.
  mfnfss -- Packages to typeset oldgerman and pandora fonts in LaTeX.
  mptopdf -- mpost to PDF, native MetaPost graphics inclusion
  natbib -- Flexible bibliography support.
  oberdiek -- A bundle of packages submitted by Heiko Oberdiek.
  pdftex-def -- Colour and Graphics support for PDFTeX.
  pslatex -- Use PostScript fonts by default.
  psnfss -- Font support for common PostScript fonts.
  pspicture -- PostScript picture support.
  tools -- The LaTeX standard tools bundle.

Package: texlive-latex-recommended
Architecture: all
Depends: texlive-latex-base (>= 2013.20130512), texlive-binaries (>= 2013.20130512), texlive-base (>= 2013.20130512), ${misc:Depends}
Recommends: texlive-latex-recommended-doc, latex-xcolor (>= 2.09), latex-beamer (>= 3.06.dfsg.1-0.1), prosper (>= 1.00.4+cvs.2006.10.22)
Provides: texlive-latex3
Description: TeX Live: LaTeX recommended packages
 A collection of recommended add-on packages for LaTeX which have widespread
   use.
 .
 This package includes the following CTAN packages:
  anysize -- A simple package to set up document margins.
  booktabs -- Publication quality tables in LaTeX
  caption -- Customising captions in floating environments.
  cite -- Improved citation handling in LaTeX.
  cmap -- Make PDF files searchable and copyable.
  crop -- Support for cropmarks.
  ctable -- Flexible typesetting of table and figure floats using key/value
   directives.
  eso-pic -- Add picture commands (or backgrounds) to every page.
  euler -- Use AMS Euler fonts for math.
  extsizes -- Extend the standard classes' size options.
  fancybox -- Variants of \fbox and other games with boxes.
  fancyref -- A LaTeX package for fancy cross-referencing.
  fancyvrb -- Sophisticated verbatim text.
  float -- Improved interface for floating objects.
  fontspec -- Advanced font selection in XeLaTeX and LuaLaTeX.
  fp -- Fixed point arithmetic.
  index -- Extended index for LaTeX including multiple indexes.
  jknapltx -- Miscellaneous packages by Joerg Knappen.
  koma-script -- A bundle of versatile classes and packages
  l3kernel -- LaTeX3 programming conventions.
  l3packages -- High-level LaTeX3 concepts.
  l3experimental -- Experimental LaTeX3 concepts.

=== debian/rules ===
#!/usr/bin/make -f
# 
# debian/rules file for texlive-base

PACKAGES=texlive-base texlive-generic-recommended texlive-latex-base texlive-latex-recommended texlive-fonts-recommended texlive-pictures texlive-luatex texlive-metapost texlive-omega texlive-xetex texlive-fonts-recommended-doc texlive-latex-base-doc texlive-latex-recommended-doc texlive-metapost-doc texlive-pictures-doc
METAPACKAGES=texlive texlive-full

SHELL=/bin/bash

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	touch build-stamp

clean: 
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  rm -f debian/$$i.{README.Debian,links,links.generated} ; \
	  rm -f debian/$$i.{postinst,postrm,preinst,prerm} ; \
	  rm -f debian/$$i.{maps,hyphens,formats,info,manpages} ; \
	  rm -f debian/$$i.{lintian-overrides} ; \
	done
	rm -f debian/texlive-base.cnf
	# texlive contains some .orig files we need to keep otherwise
	# the copy will fail due to the files occurring in the tlpdb
	dh_clean -X.orig -X.bak
	rm -f configure-stamp
	rm -f build-stamp
	rm -f install-stamp

install: install-stamp

install-stamp: build-stamp
	# make sure we have texmf-dist/web2c otherwise the media detection
	# might break (like in texlive-lang)
	mkdir -p texmf-dist/web2c
	perl debian/tpm2deb-bin.pl --nosource $(PACKAGES) $(METAPACKAGES)
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  bash debian/generate-license-file $$i ; \
	  bash debian/fix-privacy-breach $$i ; \
	  if [ -r debian/$$i.links.dist ] ; then cat debian/$$i.links.dist >> debian/$$i.links ; fi ; \
	done
	mkdir -p debian/texlive-base/etc/texmf/texdoctk
	mv debian/texlive-base/usr/share/texlive/texmf-dist/texdoctk/texdocrc.defaults \
	  debian/texlive-base/etc/texmf/texdoctk
	rmdir --ignore-fail-on-non-empty debian/texlive-base/usr/share/texlive/texmf-dist/texdoctk
	# link pfb/afm files (type1 fonts) into /usr/share/fonts
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  bash debian/create-font-links $$i >> debian/$$i.links ; \
	done
	touch install-stamp

binary-arch:

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_install
	dh_installdirs
	dh_installmenu
	dh_lintian
	dh_bugfiles -A
	dh_installdocs -A debian/README.source debian/README.Debian
	dh_installdocs -p texlive-base README readme-txt.dir readme-html.dir debian/CHANGES.packaging
	# nasty trick
	# mptopdf needs a dump, but is a link to a script
	# we have to trick dh_installtex to accept it
	mv debian/texlive-latex-base/usr/bin/mptopdf	\
		debian/texlive-latex-base/usr/bin/mptopdf.bck
	ln -s pdftex debian/texlive-latex-base/usr/bin/mptopdf
	dh_installtex -Ntexlive-base -A --priority=10	\
		$(patsubst %,-N%,$(METAPACKAGES))	\
		--flavor=lsr:full,tree:texlive
	# nasty trick undoing
	rm debian/texlive-latex-base/usr/bin/mptopdf
	mv debian/texlive-latex-base/usr/bin/mptopdf.bck	\
		debian/texlive-latex-base/usr/bin/mptopdf
	# end of nasty trick
	dh_installtex -ptexlive-base --priority=10	\
		--flavor=format:build_all,lsr:full,tree:texlive
	# /usr/bin/mf has been created by dh_installtex as symlink to 
	# mf-nowin, but is also shipped by texlive-binaries, remove it.
	rm debian/texlive-base/usr/bin/mf
	# furthermore we want to have etex and pdfetex as links in 
	# texlive-binaries and not in texlive-base, remove them here
	# and add them via dh_link in texlive-binaries
	# this is just out of history, would be nicer to have changed
	rm debian/texlive-base/usr/bin/etex 
	rm debian/texlive-base/usr/bin/pdfetex
	# for the libpaper hook, install templates and
	# translations. No need to modify postrm. I hope it accepts
	# the missing config script
	dh_installdebconf -n
	cp debian/texlive-base.libpaper debian/texlive-base/etc/libpaper.d/texlive-base
	chmod a+x debian/texlive-base/etc/libpaper.d/texlive-base
	dh_installchangelogs
	dh_installman
	bash debian/fix-manpages.sh
	# info pages
	bash debian/convert-info-files-to-unix.sh
	dh_installinfo
	# remove info files that are present in texlive-binaries
	# has to be done after the dh_installinfo call
	rm debian/texlive-base/usr/share/info/dvips.info*
	rm debian/texlive-base/usr/share/info/web2c.info*
	rm debian/texlive-base/usr/share/info/kpathsea.info*
	rmdir --ignore-fail-on-non-empty debian/texlive-base/usr/share/info
	dh_installmime
	dh_lintian
	dh_link
	dh_compress -X.pdf
	dh_fixperms
	# remove .bat files, nobody needs them
	find debian/texlive-*/usr/share/texlive/texmf-dist/ -name \*.bat -a -type f -exec rm '{}' \;
	# remove x bit from files in the doc hierarchy
	find debian/texlive-*/usr/share/doc/texlive-doc -type f -exec chmod a-x '{}' \;
	# we also have to fix the permissions of the link targets from /usr/bin
	bash debian/fix-bin-symlink-targets-permissions.sh
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb -- -Zxz

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install

# eof
